package net.wicp.tams.duckula.ops.pages.tools;

import java.util.ArrayList;
import java.util.List;

import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang3.ArrayUtils;
import org.apache.tapestry5.PersistenceConstants;
import org.apache.tapestry5.annotations.OnEvent;
import org.apache.tapestry5.annotations.Persist;
import org.apache.tapestry5.annotations.Property;
import org.apache.tapestry5.ioc.annotations.Inject;
import org.apache.tapestry5.json.JSONArray;
import org.apache.tapestry5.json.JSONObject;
import org.apache.tapestry5.util.TextStreamResponse;

import net.wicp.tams.app.duckula.controller.bean.models.SysUserPosition;
import net.wicp.tams.app.duckula.controller.bean.models.SysUserPositionExample;
import net.wicp.tams.app.duckula.controller.bean.models.SysUserPositionExample.Criteria;
import net.wicp.tams.app.duckula.controller.dao.SysUserPositionMapper;
import net.wicp.tams.app.duckula.controller.service.cas.IOrgService;
import net.wicp.tams.common.Result;
import net.wicp.tams.component.tools.TapestryAssist;
import net.wicp.tams.duckula.ops.pages.ParentPage;

public class PositionAssign extends ParentPage {
	@Inject
	private IOrgService orgService;
	@Property
	private String orgTree;
	@Persist(PersistenceConstants.CLIENT)
	@Property
	private long staffId;
	@Persist(PersistenceConstants.CLIENT)
	private JSONArray orgs;

	@Property
	private List<SysUserPosition> allPosition;// 已选中组织中拥有的群组

	@Property
	private List<String> selPosition;// 已分派到的群组
	
	@Inject
	private SysUserPositionMapper sysUserPositionMapper;

	public TextStreamResponse onInitByOrg() {
		JSONObject params=TapestryAssist.packParams(request,false);
		orgs = TapestryAssist.getParams(params,
				"orgIds");
		List<Object> orgIds = orgs==null?null:orgs.toList();
		selAll(params.getInt("staffId"), orgIds);
		JSONObject ret = TapestryAssist.buildSelGroupInit(allPosition, selPosition,
				new String[] { "caOrganization.orgName,orgName1" }, null);
		return retStream(ret.toString(true));
	}

	void onActivate(int staffId) {
		this.staffId = staffId;
		orgTree = orgService.createOrgTree(I18NConvert);
		selAll(staffId, null);
	}

	private void selAll(long staffId, List<Object> orgIds) {
		List<Long> orgidsTrue = null;
		if (orgIds != null) {
			orgidsTrue = new ArrayList<Long>();
			for (Object ele : orgIds) {
				orgidsTrue.add(Long.parseLong(String.valueOf(ele)));
			}
		}		
//		SysUserPositionExample example=new SysUserPositionExample();
//		Criteria createCriteria = example.createCriteria();
//		createCriteria+
//		sysUserPositionMapper.selectByExample(example);
//		
//		
//		Criteria criteria = session.createCriteria(CaPosition.class);
//		if (orgidsTrue != null) {
//			criteria.add(Restrictions.in("caOrganization.id", orgidsTrue));
//		}
		allPosition = new ArrayList<SysUserPosition>();
		findGroupId(staffId, orgidsTrue);
	}

	private void findGroupId(long staffId, List<Long> orgidsTrue) {
		// 查询已选择的群组
		// String alias = "group_"; //查询时的table别名
//		Criteria criteriasel = session.createCriteria(CaStaffPosition.class);
//		ProjectionList pList = Projections.projectionList();
//		pList.add(Projections.property("caPosition.id").as("positionId"));
//		criteriasel.setProjection(pList);
//		criteriasel.add(Restrictions.eq("caStaff.id", staffId));
//		if (orgidsTrue != null) {
//			criteriasel.createAlias("caPosition", "g");
//			criteriasel.add(Restrictions.in("g.caOrganization.id", orgidsTrue));
//		}
		selPosition = new ArrayList<String>();
	}

	/***
	 * 保存选择的结果
	 * 
	 * @param selIds
	 * @return
	 */
	@OnEvent(value = "save")
	private Result sava(JSONArray selIds) {
		if (selIds == null) {
			return Result.getError("需要传入要保存的对象");
		}

		// 找到已有的群组
		if (orgs == null || orgs.size() == 0) {
			findGroupId(staffId, null);
		} else {
			List<Long> orgidsTrue = new ArrayList<Long>();
			for (int i = 0; i < orgs.size(); i++) {
				orgidsTrue.add(Long.parseLong(orgs.getString(i)));
			}
			findGroupId(staffId, orgidsTrue);
		}

		long[] oriIds = new long[selPosition.size()];
		for (int i = 0; i < oriIds.length; i++) {
			oriIds[i] = Integer.parseInt(String.valueOf(selPosition.get(i)));
		}
		long[] saveIds = new long[selIds.size()];
		for (int i = 0; i < selIds.size(); i++) {
			saveIds[i] = Integer.parseInt(selIds.getString(i));
		}
		List<Long> addList = new ArrayList<Long>();// 新增
		for (int i = 0; i < saveIds.length; i++) {
			if (!ArrayUtils.contains(oriIds, saveIds[i])) {
				addList.add(saveIds[i]);
			}
		}
		if (CollectionUtils.isNotEmpty(addList)) {
			for (Long positionId : addList) {
				SysUserPosition saveobj = new SysUserPosition();
				saveobj.setPositionId(positionId); 
				saveobj.setUserId(staffId);
				sysUserPositionMapper.insert(saveobj);
			}

		}
		List<Long> delList = new ArrayList<Long>();// 删除
		for (int i = 0; i < oriIds.length; i++) {
			if (!ArrayUtils.contains(saveIds, oriIds[i])) {
				delList.add(oriIds[i]);
			}
		}

		if (CollectionUtils.isNotEmpty(delList)) {
			SysUserPositionExample example=new SysUserPositionExample();
			Criteria createCriteria = example.createCriteria();
			createCriteria.andUserIdEqualTo(staffId);
			createCriteria.andPositionIdIn(delList);			
			sysUserPositionMapper.deleteByExample(example);
		}
		return Result.getSuc();
	}
}
